%define major 1.4
%define minor 2
%define build 08
%define distversion 1_4_2_%build
%define arch i586
%define origin sun
%define priority 142

%define jdkver %major.%minor
%define label %major-%origin

Name: j2se%label
Version: %{jdkver}_%{build}
Release: alt2

%def_enable fonts
%def_disable ns4_plugin
%def_with gcc32_abi

Summary: Java 2 Runtime Environment, Standard Edition
Group: System/Base
License: Sun Binary Code License
URL: http://java.sun.com/j2se/%jdkver

%define distname    j2sdk-%distversion-linux-%arch.bin
%define java_home   %_libdir/j2se%label
%define libarch	    i386
%define fontdir     %_datadir/fonts/j2se-%origin

%if_with gcc32_abi
%define mozplugindir %java_home/jre/plugin/%libarch/ns610-gcc32
%else
%define mozplugindir %java_home/jre/plugin/%libarch/ns610
%endif

# TODO:
# - replace font.properties with font.properties.Redhat6.1
#   (or our customization)?
# - run chkfontpath on font installation?

Provides: j2se = %jdkver
Provides: jre = %jdkver, java2 = %jdkver
Provides: libjava.so(SUNWprivate_1.1)
Provides: libjvm.so(SUNWprivate_1.1)
Provides: libnet.so(SUNWprivate_1.1)
Provides: libverify.so(SUNWprivate_1.1)

Requires: j2se-%origin-fonts >= %version-%release
Requires: java-common
Requires: /proc
Requires(post,preun): alternatives >= 0.2.0

Obsoletes: %name-fonts

Source0: %distname
Source3: %name-javaws.sh

BuildArch: %arch

BuildConflicts: jdk-sun j2sdk-sun

%add_findprov_lib_path %java_home/jre/lib/%libarch
%add_findprov_lib_path %java_home/jre/lib/%libarch/client
%add_findprov_lib_path %java_home/jre/lib/%libarch/server
%add_findprov_lib_path %java_home/jre/lib/%libarch/native_threads

%define _compress_method gzip

%define _verify_elf_method textrel=relaxed

%package devel
Summary: Java 2 SDK, Standard Edition
Group: Development/Java
Provides: j2se-devel = %jdkver
Provides: jdk = %jdkver, j2sdk = %jdkver
Requires: %name = %version-%release
Requires(post,preun): alternatives >= 0.2.0
Obsoletes: jdk-sun j2sdk-sun

%package source
Summary: Source files for the Java 2 SDK
Group: Development/Java

%package demo
Summary: Demo applets and programs for the Java 2 SDK
Group: Development/Java
AutoReqProv: no

%package plugin-mozilla
Summary: Java Plug-In for Mozilla and Netscape 6
Group: Networking/WWW
Provides: java2-plugin-mozilla = %jdkver
Requires: %name = %version-%release
Requires: browser-plugins-npapi
Requires(post,preun): alternatives >= 0.2.0

%if_enabled ns4_plugin
%package plugin-netscape4
Summary: Java Plug-In for Netscape 4.x
Group: Networking/WWW
Provides: java2-plugin-netscape4 = %jdkver
Requires: %name = %version-%release
Requires: netscape-common
Requires(post,preun): alternatives >= 0.2.0
%endif

%package jdbc
Summary: Native library for JDBC support in Java
Group: Development/Databases
Provides: j2se-jdbc = %jdkver
Requires: %name = %version-%release

%package javaws
Summary: Java Web Start
Group: Networking/Other
Provides: javaws = %jdkver
Requires: %name = %version-%release
Requires(post,preun): alternatives >= 0.2.0

%if_enabled fonts
%package -n j2se-%origin-fonts
Summary: TrueType fonts for Java 2 Standard Edition
Group: System/Fonts/True type
PreReq: fontconfig
Provides: java_sun-fonts = %version-%release
%endif	# enabled fonts

%description
The Java 2 Runtime Environment contains the Java virtual machine, 
runtime class libraries, and Java application launcher that are 
necessary to run programs written in the Java programming language. 
It is not a development environment and does not contain development 
tools such as compilers or debuggers.  For development tools, see the 
Java 2 SDK, Standard Edition.

This package contains J2SE Runtime Environment created by Sun Microsystems.
Install this package if you need to run Java applications.

%description devel
The Java 2 SDK is a development environment for building applications,
applets, and components using the Java programming language.

The Java 2 SDK includes tools useful for developing and testing programs
written in the Java programming language and running on the Java platform.

This package contains J2SE SDK created by Sun Microsystems.
Install this package if you need to develop and build Java applications.

%description source
Java programming language source files for all classes that make up
the Java 2 core API.

%description demo
Examples, with source code, of programming for the Java platform. These include
examples that use Swing and other Java Foundation Classes, and the Java
Platform Debugger Architecture.

%description plugin-mozilla
This package contains Java(TM) 2 Plug-In for Mozilla and Netsape 6/7
web browsers.

%if_enabled ns4_plugin
%description plugin-netscape4
This package contains Java(TM) 2 Plug-In for Netsape 4.x web browser.
%endif

%description jdbc
This package contains a native dynamic library that provides JDBC support
for the Java platform via the ODBC interface. This library is a part of
the Sun J2SE bundle.

%description javaws
Java Web Start is a deployment solution for Java-technology-based
applications. It is the plumbing between the computer and the Internet
that allows the user to launch and manage applications right off the
Web. Java Web Start provides easy, one-click activation of
applications, and guarantees that you are always running the latest
version of the application, eliminating complicated installation or
upgrade procedures.

This package provides the Java Web Start installation that is bundled
with J2SE Runtime Environment by Sun Microsystems.

%if_enabled fonts
%description -n j2se-%origin-fonts
This package contains the TrueType fonts distributed with
Sun Java 2 Standard Edition.
%endif	# enabled fonts

%prep
MORE=10000 sh %SOURCE0 <<EOF
yes
EOF
%setup -T -D -n j2sdk%version
# fix perms
chmod -R u+w *

echo j2se >j2se-buildreq-substitute
echo j2se-devel >j2se-devel-buildreq-substitute

cat >README.alt <<EOF
The Java 2 Runtime Environment and SDK, Standard Edition are distributed
within this and related packages as shown below:

%name		- Java 2 Runtime Environment, Standard Edition
			  (with notable omissions listed below).
%name-devel	- Java 2 SDK, Standard Edition.
%name-source	- Java 2 Standard Edition API source files.
%name-demo	- Java 2 SDK demo applets and programs.
%name-jdbc	- JDBC provider library using ODBC.
			  This library was excluded from the
			  %name package due to outstanding dependencies.
%name-javaws	- Java Web Start software that is bundled with
			  Java 2 Runtime Environment, Standard Edition
%name-plugin-mozilla	- Java 2 plug-in for Mozilla and Netscape 6/7.
%name-plugin-netscape4	- Java 2 plug-in for Netscape 4.x (optional).
j2se-%origin-fonts		- The TrueType fonts in %fontdir,
			  shared between various installations of
			  the Java 2 Runtime Environment.

See the README, LICENSE, COPYRIGHT, and THIRDPARTYLICENSEREADME.txt files
for copyright information, terms of use and redistribution covering contents
of these packages.
EOF

%if_enabled fonts
cat >jre/lib/fonts/README.alt <<EOF
The fonts contained in this package are part of the
Java 2 Runtime Environment, Standard Edition (J2SE).
This package is required by packages containing various versions
of J2SE.

See the LICENSE, COPYRIGHT, and THIRDPARTYLICENSEREADME.txt files
for copyright information, terms of use and redistribution covering contents
of this package.
EOF
%endif	# enabled fonts

%install
# Main files
install -d -m755 $RPM_BUILD_ROOT%java_home
cp -a bin include lib $RPM_BUILD_ROOT%java_home
install -d -m755 $RPM_BUILD_ROOT%java_home/jre
cp -a jre/{bin,javaws,lib,plugin,ControlPanel.html} $RPM_BUILD_ROOT%java_home/jre

# Install profile scripts
cat >$RPM_BUILD_ROOT%java_home/j2se.sh <<EOF
JAVA_HOME=%java_home
export JAVA_HOME
EOF
chmod 755 $RPM_BUILD_ROOT%java_home/j2se.sh
cat >$RPM_BUILD_ROOT%java_home/j2se.csh <<EOF
setenv JAVA_HOME %java_home
EOF
chmod 755 $RPM_BUILD_ROOT%java_home/j2se.csh

# Demo and sources
install -d -m755 $RPM_BUILD_ROOT%_datadir/%name
cp -a demo $RPM_BUILD_ROOT%_datadir/%name
install -m644 src.zip $RPM_BUILD_ROOT%_datadir/%name

%if_enabled fonts
# Move the fonts into a shared fonts directory
install -d -m755 $RPM_BUILD_ROOT%fontdir
mv $RPM_BUILD_ROOT%java_home/jre/lib/fonts/* $RPM_BUILD_ROOT%fontdir
rmdir $RPM_BUILD_ROOT%java_home/jre/lib/fonts
%else	# disabled fonts
rm -rf $RPM_BUILD_ROOT%java_home/jre/lib/fonts
%endif	# enabled fonts
ln -s %fontdir $RPM_BUILD_ROOT%java_home/jre/lib/fonts

# Java Web Start binary
install -m755 %SOURCE3 $RPM_BUILD_ROOT%java_home/jre/javaws/javaws-%_vendor

# Move and label the manpages
mkdir -p $RPM_BUILD_ROOT%_man1dir
for f in man/man1/*; do
    install -p -m644 $f $RPM_BUILD_ROOT%_man1dir/$(basename $f .1)%label.1
done

# Install substitute rules for buildreq
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
install -m644 j2se-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name
install -m644 j2se-devel-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name-devel

%__install -d $RPM_BUILD_ROOT%_altdir

# J2SE alternative
%__cat <<EOF >%buildroot%_altdir/%name-j2se
%_libdir/j2se	%java_home	%priority
%_man1dir/java.1.gz	%_man1dir/java%{label}.1.gz	%java_home
EOF
# binaries and manuals
for i in keytool policytool servertool
do
  %__cat <<EOF >>%buildroot%_altdir/%name-j2se
%_bindir/$i	%java_home/jre/bin/$i	%java_home
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home
EOF
done
# server binaries
for i in orbd rmid rmiregistry tnameserv
do
  %__cat <<EOF >>%buildroot%_altdir/%name-j2se
%_sbindir/$i	%java_home/jre/bin/$i	%java_home
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home
EOF
done

# Javac alternative
%__cat <<EOF >%buildroot%_altdir/%name-javac
%_bindir/javac	%java_home/bin/javac	%priority
%_libdir/jdk	%java_home	%java_home/bin/javac
%_man1dir/javac.1.gz	%_man1dir/javac%{label}.1.gz	%java_home/bin/javac
EOF
# binaries and manuals
for i in appletviewer extcheck idlj jar jarsigner javadoc javah javap jdb native2ascii rmic serialver
do
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_bindir/$i	%java_home/bin/$i	%java_home/bin/javac
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home/bin/javac
EOF
done
# profiles
for i in j2se.sh j2se.csh
do
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_sysconfdir/profile.d/$i	%java_home/$i	%java_home/bin/javac
EOF
done

# Mozilla plugin alternative
%__cat <<EOF >%buildroot%_altdir/%name-mozilla
%_libdir/browser-plugins-npapi/libjavaplugin_oji.so	%mozplugindir/libjavaplugin_oji.so	%priority
EOF

# Netscape 4.x plugin alternative
%__cat <<EOF >%buildroot%_altdir/%name-ns4
%_libdir/netscape/plugins/javaplugin.so	%java_home/jre/plugin/%libarch/ns4/javaplugin.so	%priority
EOF

# Java Web Start alternative
%__cat <<EOF >%buildroot%_altdir/%name-javaws
%_bindir/javaws	%java_home/jre/bin/javaws-%_vendor	%priority
%_man1dir/javaws.1.gz	%_man1dir/javaws%label.1.gz	%java_home/jre/bin/javaws
EOF

%post
%register_alternatives %name-j2se

%pre
[ -L %java_home/jre/lib/fonts ] || %__rm -rf %java_home/jre/lib/fonts

%preun
%unregister_alternatives %name-j2se

%post devel
%register_alternatives %name-javac

%preun devel
%unregister_alternatives %name-javac

%post plugin-mozilla
if [ -d %_libdir/browser-plugins-npapi ]; then
%register_alternatives %name-mozilla
fi

%preun plugin-mozilla
%unregister_alternatives %name-mozilla

%if_enabled ns4_plugin
%post plugin-netscape4
if [ -d %_libdir/netscape/plugins ]; then
%register_alternatives %name-ns4
fi

%preun plugin-netscape4
%unregister_alternatives %name-ns4
%endif

%post javaws
%register_alternatives %name-javaws

%preun javaws
%unregister_alternatives %name-javaws

%if_enabled fonts
%post -n j2se-%origin-fonts
%_bindir/fc-cache %fontdir

%triggerpostun -n j2se-%origin-fonts -- j2se1.3-sun-fonts j2se1.4-sun-fonts j2se1.4-blackdown-fonts
# Recreate the cache removed by the font uninstall scripts
%_bindir/fc-cache %fontdir

%preun -n j2se-%origin-fonts
if [ $1 = 0 ]; then
    %__rm -f %fontdir/fonts.cache*
fi
%endif	# enabled fonts

%files
%doc jre/CHANGES jre/COPYRIGHT jre/LICENSE jre/README jre/Welcome.html
%doc jre/THIRDPARTYLICENSEREADME.txt
%doc README.alt
%_altdir/%name-j2se
%_sysconfdir/buildreqs/packages/substitute.d/%name
%dir %java_home
%dir %java_home/jre
%dir %java_home/jre/plugin
%dir %java_home/jre/plugin/%libarch
%dir %java_home/jre/lib
%dir %java_home/jre/lib/security
%dir %_datadir/%name
%java_home/jre/ControlPanel.html
%java_home/jre/bin
%java_home/jre/lib/%libarch
%exclude %java_home/jre/lib/%libarch/libJdbcOdbc.so
%java_home/jre/lib/*.jar
%java_home/jre/lib/*.txt
%java_home/jre/lib/applet
%java_home/jre/lib/audio
%java_home/jre/lib/cmm
%java_home/jre/lib/ext
%java_home/jre/lib/fonts
%java_home/jre/lib/im
%java_home/jre/lib/images
%java_home/jre/lib/locale
%java_home/jre/lib/zi
%config(noreplace) %java_home/jre/lib/*.properties
%config(noreplace) %java_home/jre/lib/*.properties.??
%config(noreplace) %java_home/jre/lib/%libarch/jvm.cfg
%config(noreplace) %java_home/jre/lib/security/cacerts
%config(noreplace) %java_home/jre/lib/security/java.policy
%config(noreplace) %java_home/jre/lib/security/java.security
%java_home/jre/lib/font.properties.Redhat*
%java_home/jre/lib/font.properties.SuSE*
%doc %java_home/jre/lib/%libarch/*/Xusage.txt
%java_home/jre/lib/security/*.jar
%_man1dir/java%label.1*
%_man1dir/keytool%label.1*
%_man1dir/kinit%label.1*
%_man1dir/klist%label.1*
%_man1dir/ktab%label.1*
%_man1dir/orbd%label.1*
%_man1dir/policytool%label.1*
%_man1dir/rmid%label.1*
%_man1dir/rmiregistry%label.1*
%_man1dir/servertool%label.1*
%_man1dir/tnameserv%label.1*

%files devel
%doc *README* LICENSE COPYRIGHT
%_altdir/%name-javac
%_sysconfdir/buildreqs/packages/substitute.d/%name-devel
%config %java_home/j2se.*sh
%java_home/bin
%java_home/lib
%java_home/include
%_man1dir/appletviewer%label.1*
%_man1dir/extcheck%label.1*
%_man1dir/idlj%label.1*
%_man1dir/jar%label.1*
%_man1dir/jarsigner%label.1*
%_man1dir/javac%label.1*
%_man1dir/javadoc%label.1*
%_man1dir/javah%label.1*
%_man1dir/javap%label.1*
%_man1dir/jdb%label.1*
%_man1dir/native2ascii%label.1*
%_man1dir/rmic%label.1*
%_man1dir/serialver%label.1*

%files source
%_datadir/%name/src.zip

%files demo
%_datadir/%name/demo

%files plugin-mozilla
%_altdir/%name-mozilla
%mozplugindir

%if_enabled ns4_plugin
%files plugin-netscape4
%_altdir/%name-ns4
%java_home/jre/plugin/%libarch/ns4
%endif

%files jdbc
%java_home/jre/lib/%libarch/libJdbcOdbc.so

%files javaws
%doc README.alt
%_altdir/%name-javaws
%dir %java_home/jre/javaws
%java_home/jre/javaws/javaws
%java_home/jre/javaws/javawsbin
%java_home/jre/javaws/javaws-%_vendor
%java_home/jre/javaws/*.jar
%java_home/jre/javaws/*.gif
%doc %java_home/jre/javaws/*.html
%java_home/jre/javaws/resources
%config(noreplace) %java_home/jre/javaws/javaws.policy
%config(noreplace) %java_home/jre/javaws/cacerts
%_man1dir/javaws%label.1*

%if_enabled fonts
%files -n j2se-%origin-fonts
%doc LICENSE COPYRIGHT THIRDPARTYLICENSEREADME.txt
%doc jre/lib/fonts/README.alt
%dir %fontdir
%config %fontdir/fonts.dir
%fontdir/*.ttf
%endif	# enabled fonts

%changelog
* Mon Jul 25 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_08-alt2
- Moved the mozilla plugins alternative symlink to browser-plugins-npapi
  [bug 7461]

* Sat Jun 25 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_08-alt1
- Updated to 1.4.2_08

* Thu Nov 25 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_06-alt1
- New upstream release and a security fix
- Moved to the new alternatives scheme
- Stop using generated filelist for native libraries, use %%exclude instead

* Sat Aug 07 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_05-alt2
- Require /proc

* Sat Jul 03 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_05-alt1
- New upstream release

* Wed Jun 16 2004 Stanislav Ievlev <inger@altlinux.org> 1.4.2_04-alt2.1
- NMU: move to new alternatives scheme

* Sat Mar 13 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_04-alt2
- Added jvm.jprof.txt and jvm.jcov.txt to the JRE file list
- Conditionally-disabled fonts, enabled by default

* Wed Mar 10 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_04-alt1
- Bugfix upstream release

* Mon Dec 22 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_03-alt1
- Bugfix upstream release

* Fri Dec 19 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_02-alt3
- Added /usr/sbin/update-alternatives to install-time dependencies

* Wed Dec 03 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_02-alt2
- Fixed filelist bug

* Wed Nov 12 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_02-alt1
- New upstream release
- Relaxed TEXTREL check on ELF files
- Added some files that were reported as unlisted

* Thu Oct 23 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_01-alt2
- Added locations of binary libraries to %%_findprov_lib_path

* Sat Oct 04 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_01-alt1
- New upstream release

* Sun Jul 13 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2-alt1
- J2SE 1.4.2
- Reformed fonts package into j2se-sun-fonts, shared between various
  J2SE installations
- javaws subpackage for the bundled Java Web Start
- Added kinit, klist and ktab manpages to the filelist.
  The tools themselves will not be symlinked to /usr/bin
  due to conflicts with the krb5-workstation package
- Created README.alt describing package layout specifics,
  as required by the J2SE license

* Tue Mar 18 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_02-alt1
- 1.4.1_02

* Tue Jan 14 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt5
- Added Requires: to devel subpackage for the main package

* Thu Dec 26 2002 AEN <aen@altlinux.ru> 1.4.1_01-alt4
- added Provides: java_sun-fonts to fonts package

* Mon Nov 18 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt3
- The j2se package does not provide /usr/bin/java, instead it requires
  java-common
- Moved profile scripts to /usr/lib/j2se1.4-sun

* Wed Nov 13 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt2
- The j2se package provides /usr/bin/java
- Target profile scripts moved out of /etc/profile.d to /usr/share/j2se1.4-sun

* Tue Nov 12 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt1
- Renamed to j2se1.4-sun
- Renamed subpackages: src to source, odbc to jdbc
- Added fonts subpackage, using fontconfig
- Moved demo and source to /usr/share/j2se1.4-sun
- Provide /usr/lib/jdk as an alternatives-driven link, for seamless upgrades
  from obsolete JDK packages to j2se1.4-sun-devel

* Tue Jun 18 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.0_01-alt1
- Renamed to j2sdk-sun
- Arch is now i586
- Eliminated chdirs in the install script
- Included JRE README and license in the file list

* Sat Mar 30 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.0-alt2
- Bumped to alt2. Thanks, Ivan, you did all the work.
- Added orbd and servertool to executable symlinks
- spec cleanup

* Sat Mar  2 2002 Ivan Zakharyaschev <imz@altlinux.ru> 1.4.0-alt1imz
- 1.4.0
- NOT DONE: Sun Inc. changed the name from jdk to j2sdk; we change it, too: it sounds
  logical (1.4.0 is the version of Java2);
- 4 entries in %%files changed:
  + include-old dropped;
  + jre/lib/tzmappings files replaced by zi/ subdirectory;
  + jre/lib/jvm.cfg moved into i386/ subdirectory;
  + src.jar -> src.zip;
- using ns610 instead of ns600 plugin for Mozilla; now the version
  of Java2 environment is appended to the plugin libraries --
  modify scriplets accordingly;

* Sat Jun 16 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.1-alt2
- corrected generation of the filelist

* Sat Jun 16 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.1-alt1
- 1.3.1
- config(noreplace) on configuration files
- odbc subpackage

* Fri May 04 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.0_02-alt3
- Omit version in install directory name to make upgrades painless
- Fixed uninstallation scripts

* Sat Apr 28 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.0_02-alt2
- Unbundled plugins because they cast excessive dependencies
- update-alternatives for plugins

* Fri Apr 27 2001 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.0_02-alt1
- Updated version
- New distribution
- Renamed to jdk-sun to leave room for jdk-ibm or others

* Sun Dec 10 2000 Mikhail Zabaluev <mookid@sigent.ru> 1.3-1mdk_mhz
- initial package
